- Main Page
- Modules
- Data Structures
- Files
- Related Pages

- File List
- Globals

# rpmio/rpmlog.c File Reference

`#include "system.h"`
`#include <stdarg.h>`
`#include "rpmlog.h"`
`#include "debug.h"`

Go to the source code of this file.

## Defines
#define | va_copy(DEST, SRC) ((DEST) = (SRC))
## Functions
static void * | _free (const void *p)
| Wrapper to free(3), hides const compilation noise, permit NULL, return NULL.
int | rpmlogGetNrecs (void)
int | rpmlogCode (void)
const char * | rpmlogMessage (void)
void | rpmlogPrint (FILE *f)
void | rpmlogClose (void)
void | rpmlogOpen (const char *ident, int option, int facility)
int | rpmlogSetMask (int mask)
rpmlogCallback | rpmlogSetCallback (rpmlogCallback cb)
static int | vsnprintf (char *buf, int nb, const char *fmt, va_list ap)
static void | vrpmlog (unsigned code, const char *fmt, va_list ap)
void | rpmlog (int code, const char *fmt,...)
int | rpmErrorCode (void)
const char * | rpmErrorString (void)
rpmlogCallback | rpmErrorSetCallback (rpmlogCallback cb)
## Variables
static int | nrecs = 0
static rpmlogRec | recs = NULL
static unsigned | rpmlogMask = ((1 << (((unsigned)( RPMLOG_NOTICE ))+1)) - 1)
static unsigned | rpmlogFacility = RPMLOG_USER
static rpmlogCallback | _rpmlogCallback = NULL
static char * | rpmlogMsgPrefix []

## Detailed Description

Definition in file rpmlog.c.

## Define Documentation

#define va_copy | ( | DEST,
|  | SRC |  | ) | ((DEST) = (SRC))

Definition at line 17 of file rpmlog.c.

Referenced by vrpmlog().

## Function Documentation

static void* _free | ( | const void * | p | ) | `[inline, static]`

Wrapper to free(3), hides const compilation noise, permit NULL, return NULL.

Parameters:

  | p | memory to free

Return values:

  | NULL | always

Definition at line 35 of file rpmlog.c.

int rpmErrorCode | ( | void |  | ) |

Definition at line 248 of file rpmlog.c.

References rpmlogCode().

rpmlogCallback rpmErrorSetCallback | ( | rpmlogCallback | cb | ) |

Definition at line 258 of file rpmlog.c.

References rpmlogSetCallback().

const char* rpmErrorString | ( | void |  | ) |

Definition at line 253 of file rpmlog.c.

References rpmlogMessage().

void rpmlog | ( | int | code,
|  | const char * | fmt,
|  |  | ... |
| ) |  |  |

Definition at line 237 of file rpmlog.c.

References vrpmlog().

Referenced by getGidS(), getGname(), getGnameS(), getUidS(), getUname(), and getUnameS().

void rpmlogClose | ( | void |  | ) |

Definition at line 78 of file rpmlog.c.

References _free(), nrecs, and recs.

Referenced by main().

int rpmlogCode | ( | void |  | ) |

Definition at line 46 of file rpmlog.c.

References nrecs, and recs.

Referenced by rpmErrorCode().

int rpmlogGetNrecs | ( | void |  | ) |

Definition at line 41 of file rpmlog.c.

References nrecs.

const char* rpmlogMessage | ( | void |  | ) |

Definition at line 54 of file rpmlog.c.

References _, nrecs, and recs.

Referenced by rpmErrorString().

void rpmlogOpen | ( | const char * | ident,
|  | int | option,
|  | int | facility |
| ) |  |  |

Definition at line 93 of file rpmlog.c.

void rpmlogPrint | ( | FILE * | f | ) |

Definition at line 62 of file rpmlog.c.

References nrecs, and recs.

rpmlogCallback rpmlogSetCallback | ( | rpmlogCallback | cb | ) |

Definition at line 117 of file rpmlog.c.

References _rpmlogCallback.

Referenced by rpmErrorSetCallback().

int rpmlogSetMask | ( | int | mask | ) |

Definition at line 104 of file rpmlog.c.

References rpmlogMask.

static void vrpmlog | ( | unsigned | code,
|  | const char * | fmt,
|  | va_list | ap |
| ) |  |  | `[static]`

< mask for one priority

< mask to extract facility part

Definition at line 151 of file rpmlog.c.

References _, _free(), _rpmlogCallback, EXIT_FAILURE, nrecs, recs, rpmlogMask, rpmlogMsgPrefix, va_copy, vsnprintf(), xmalloc(), and xrealloc().

Referenced by rpmlog().

static int vsnprintf | ( | char * | buf,
|  | int | nb,
|  | const char * | fmt,
|  | va_list | ap |
| ) |  |  | `[inline, static]`

Definition at line 141 of file rpmlog.c.

## Variable Documentation

rpmlogCallback _rpmlogCallback = NULL`[static]`

Definition at line 115 of file rpmlog.c.

Referenced by rpmlogSetCallback(), and vrpmlog().

int nrecs = 0`[static]`

Definition at line 25 of file rpmlog.c.

Referenced by rpmlogClose(), rpmlogCode(), rpmlogGetNrecs(), rpmlogMessage(), rpmlogPrint(), and vrpmlog().

rpmlogRec recs = NULL`[static]`

Definition at line 27 of file rpmlog.c.

Referenced by handleOverlappedFiles(), rpmlogClose(), rpmlogCode(), rpmlogMessage(), rpmlogPrint(), and vrpmlog().

unsigned rpmlogFacility = RPMLOG_USER`[static]`

Definition at line 102 of file rpmlog.c.

unsigned rpmlogMask = ((1 << (((unsigned)( RPMLOG_NOTICE ))+1)) - 1)`[static]`

all priorities through pri

Definition at line 99 of file rpmlog.c.

Referenced by rpmlogSetMask(), and vrpmlog().

char* rpmlogMsgPrefix[]`[static]`

Initial value:

     {
         "fatal error: " ,
         "fatal error: " ,
         "fatal error: " ,
         "error: " ,
         "warning: " ,
        "",
        "",
        "D: ",
    }

Definition at line 128 of file rpmlog.c.

Referenced by vrpmlog().